--- removepkg.orig	2009-09-06 22:07:53.000000000 +0100
+++ removepkg	2009-09-06 22:14:34.000000000 +0100
@@ -1,6 +1,9 @@
 #!/bin/sh
 # Slackware remove package script
 #
+# Sun Sep  6 21:58:36 BST 2009
+# Replaced pkgbase & package_name code with 'sed' script by Jim Hawkins.
+#
 # Sat Apr 25 21:18:53 UTC 2009 (12.34567890b)
 # Converted to use new pkgbase() function to remove pathname and
 # valid package extensions.
@@ -96,25 +99,8 @@
 # Return a package name that has been stripped of the dirname portion
 # and any of the valid extensions (only):
 pkgbase() {
-  PKGEXT=$(echo $1 | rev | cut -f 1 -d . | rev)
-  case $PKGEXT in
-  'tgz' )
-    PKGRETURN=$(basename $1 .tgz)
-    ;;
-  'tbz' )
-    PKGRETURN=$(basename $1 .tbz)
-    ;;
-  'tlz' )
-    PKGRETURN=$(basename $1 .tlz)
-    ;;
-  'txz' )
-    PKGRETURN=$(basename $1 .txz)
-    ;;
-  *)
-    PKGRETURN=$(basename $1)
-    ;;
-  esac
-  echo $PKGRETURN
+  # basename + strip extensions .tbz, .tgz, .tlz and .txz
+  echo "$1" | sed 's?.*/??;s/\.t[bglx]z$//'
 }
 
 # This makes "sort" run much faster:
@@ -271,38 +257,14 @@
 }
 
 package_name() {
-  STRING=$(pkgbase $1)
+  STRING=$(pkgbase $1 | sed 's?-[^-]*-[^-]*-[^-]*$??')
   # If we don't do this, commands run later will take the '-' to be an option
   # and will destroy the package database.  Packages should not contain spaces
   # in them.  Normally this type of problem results from a command line typo.
   if [ "$(echo $STRING | cut -b 1)" = "-" ]; then
     STRING="malformed-package-name-detected"
   fi
-  # Check for old style package name with one segment:
-  if [ "$(echo $STRING | cut -f 1 -d -)" = "$(echo $STRING | cut -f 2 -d -)" ]; then
-    echo $STRING
-  else # has more than one dash delimited segment
-    # Count number of segments:
-    INDEX=1
-    while [ ! "$(echo $STRING | cut -f $INDEX -d -)" = "" ]; do
-      INDEX=$(expr $INDEX + 1)
-    done
-    INDEX=$(expr $INDEX - 1) # don't include the null value
-    # If we don't have four segments, return the old-style (or out of spec) package name:
-    if [ "$INDEX" = "2" -o "$INDEX" = "3" ]; then
-      echo $STRING
-    else # we have four or more segments, so we'll consider this a new-style name:
-      NAME=$(expr $INDEX - 3)
-      NAME="$(echo $STRING | cut -f 1-$NAME -d -)"
-      echo $NAME
-      # cruft for later ;)
-      #VER=$(expr $INDEX - 2)
-      #VER="$(echo $STRING | cut -f $VER -d -)"
-      #ARCH=$(expr $INDEX - 1)
-      #ARCH="$(echo $STRING | cut -f $ARCH -d -)"
-      #BUILD="$(echo $STRING | cut -f $INDEX -d -)"
-    fi
-  fi
+  echo $STRING
 }
 
 # Conversion to 'comm' utility by Mark Wisdom.
